package org.greenstone.gsdl3.gs3build.util;

import java.util.*;

public class HTMLTagVector
{ Vector vector;

	//
	// private: creates a Vector of tags from a comma separated list
	//
	public HTMLTagVector(String list)
	{ int pos;
		String tagname;

		this.vector = new Vector(1);

		// get first index
		pos = list.indexOf(',');

		// add leading tag to index, if there is > 1 tag currently
		// in the list, and discard the tag
		while (pos >= 0)
		{ tagname = list.substring(0, pos);
			list		= list.substring(pos+1, list.length());
			this.vector.addElement((Object) tagname);

			pos			= list.indexOf(',');
		}

		// add the last tag to the list
		tagname = list;
		this.vector.addElement((Object) tagname);
	}

	public HTMLTagVector(Vector vector)
	{ this.vector = vector;
	}

	/**
	 * Check whether a given tag is in the tagVector.  If <CODE>opening</CODE> is false,
	 * then the method will return true for both opening and closing versions of the tag.
	 * If the
	 */
	public boolean matches(HTMLTag tag, boolean opening)
	{ int tagref;

		if (tag.xtagName() == null)
		{	return false;
		}

		for (tagref = 0; tagref < this.vector.size(); tagref ++)
		{ if ((tag.xtagName().equals((String) this.vector.elementAt(tagref))) &&
		      (tag.tagIsOpening() || !opening))
			{ return true;
			}
		}
		return false;
	}

}